<template>
  <div class="rf">
    <input
      :id="`type-menu-toggle-${_uid}`"
      ref="typeMenuToggle"
      type="checkbox"
      class="type-menu-toggle d-none"
    />
    <div class="rf-wrapper">
      <div class="container m-container-no-gutter">
        <div class="rf-primary row align-items-center justify-content-between">
          <div class="d-none d-md-block col-12 col-xl-7 mb-4 mb-xl-0">
            <div class="row tabs align-items-center">
              <div class="col col-auto tabs__title">
                {{
                  $t("preorderTutorial.detailItem.selectRestaurant.service")
                }}：
              </div>
              <div class="col">
                <div class="row">
                  <div v-for="(tab, key) in tabs" class="col" :key="key">
                    <label class="d-block tab" :class="`tab--${key}`">
                      <input
                        class="d-none"
                        type="checkbox"
                        v-model="service[key]"
                        :disabled="service[key] == 'disabled'"
                        :true-value="true"
                        :false-value="false"
                        @click="updateFilter({ service })"
                      />
                      <span class="d-block tab__cube">
                        <i class="d-inline-block tab__check">&#10003;</i>
                        <img :src="`/static/images/icons/${key}.png`" alt="" />
                        <span class="tab__text text-white">{{ tab }}</span>
                      </span>
                    </label>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div class="col-12 col-xl-4">
            <div class="row">
              <div class="col col-6">
                <div class="rf-secondary-column">
                  <label
                    :for="`type-menu-toggle-${_uid}`"
                    class="type-menu-trigger pointer d-block"
                  >
                    {{ $t(`restaurantTypes.${type}`) }}
                    <i class="ic-sm-arrow"></i>
                  </label>
                </div>
              </div>
              <div class="col col-6">
                <div class="rf-secondary-column">
                  <router-link
                    class="type-menu-help pointer d-block"
                    :to="'/preorder-tutorial'"
                  >
                    {{ $t(`preorderTutorial.needHelps`) }}
                    <i class="ic-sm-arrow"></i>
                  </router-link>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="type-menu">
      <div class="container m-container-no-gutter">
        <input
          v-for="(t, key) in types"
          :key="key"
          :id="`type-${t}`"
          class="d-none"
          type="radio"
          :value="t"
          v-model="type"
        />
        <div class="type-list-container">
          <div ref="typeMenuList" class="type-list">
            <div
              v-for="(t, key) in types"
              :key="key"
              :id="`type-${t}-toggle`"
              class="type-item pointer"
              @click="type = t"
            >
              <div class="type-item-inner-wrapper">
                <div class="type-item-image" :class="`type-item-image--${t}`">
                  <div class="type-item-name">
                    {{ $t(`restaurantTypes.${t}`) }}
                  </div>
                </div>
              </div>
            </div>
            <div class="type-item type-item--fake"></div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import { mapState, mapActions, mapGetters } from "vuex";
import $ from "jquery";
import _ from "underscore";
import sessionTimeMappings from "@/const/sessionTimeMappings";

export default {
  data() {
    return {
      sessionTimeMappings
    };
  },
  computed: {
    ...mapState(["isMobile"]),
    ...mapState("group", ["group", "filter", "restaurants"]),
    ...mapGetters("group", ["availableStrategies", "vipAvailableStrategies"]),
    ...mapGetters("account", ["isVipMember"]),
    memberAvailableStrategies() {
      return this.isVipMember
        ? this.vipAvailableStrategies
        : this.availableStrategies;
    },
    tabs() {
      return this.$t("restaurant.tab");
    },
    types() {
      return [
        "chinese",
        "japanese",
        "korean",
        "american",
        "vegi",
        "southeastasia",
        "italian",
        "hk",
        "bbq",
        "cafe",
        "teppanyaki",
        "hotpot",
        "steak",
        "allucaneat",
        "family",
        "all"
      ].filter(t => {
        return (
          this.restaurants.any(r => !!~r.restaurantTypes.indexOf(t)) ||
          t === "all"
        );
      });
    },
    service: {
      get() {
        return this.$store.state.group.filter.service;
      },
      set(service) {
        this.updateFilter({ service });
      }
    },
    strategy: {
      get() {
        return this.$store.state.group.filter.strategy || "waiting";
      },
      set(strategy) {
        this.updateFilter({ strategy });
      }
    },
    sessionTime() {
      return this.$store.state.group.filter.sessionTime;
    },
    type: {
      get() {
        return this.$store.state.group.filter.type;
      },
      set(val) {
        this.updateFilter({ type: val });
      }
    }
  },
  watch: {
    isMobile() {},
    strategies(nv) {
      if (nv && nv.length > 0 && nv.indexOf(this.strategy) == -1) {
        this.strategy = nv[0];
      }
    },
    type(val) {
      window.gtag("event", "Filter - Choose", {
        event_label: JSON.stringify({ name: val, group_id: this.group.id })
      });
      this.$refs.typeMenuToggle.checked = false;
    }
  },
  methods: {
    ...mapActions("group", ["updateFilter"])
  }
};
</script>
<style lang="scss" scoped>
$strategy-list: waiting bookingNoon bookingAfternoon bookingNight;
$type-list: "chinese", "japanese", "korean", "american", "vegi", "southeastasia",
  "italian", "hk", "bbq", "cafe", "teppanyaki", "hotpot", "steak", "allucaneat",
  "family";

@include radio-connect("strategy", $strategy-list) {
  color: $color-skm-red;
  border-bottom-color: rgba($color-skm-red, 1);

  .rf-strategy-session {
    display: inline;
  }
}

@include radio-connect("type", $type-list) {
  .type-item-image:after {
    background-color: rgba(210, 29, 29, 0.85);
  }
}

.rf {
  position: relative;
  z-index: 3;
  background-color: $color-white;
  font-size: 14px;
  @include media-breakpoint-up(md) {
    font-size: 16px;
  }
}

.rf-wrapper {
  box-shadow: 0px 6px 12px rgba(0, 0, 0, 0.03);
  width: 100%;
  .rf-primary {
    padding: 20px 0;
    &.row {
      margin: 0 -4px;
    }
    .col {
      padding: 0 4px;
    }
  }
}

.rf-secondary-column {
  flex-shrink: 0;
  border: 1px solid $color-silver-grey;
  padding: 8px 0;
}

.rf-primary-column {
  flex: 1 2 0%;
  min-width: 0px;
  height: 100%;
  position: relative;
  white-space: nowrap;
  &:after {
    content: "";
    position: absolute;
    right: 0;
    top: 0;
    width: 25%;
    height: 47px;
    background-image: linear-gradient(
      to right,
      rgba(255, 255, 255, 0),
      #ffffff
    );
    pointer-events: none;
  }

  @include media-breakpoint-up(md) {
    height: 53px;
  }
}

.filter-list-container {
  height: 47px;
  overflow: hidden;
}

.rf-strategy-list {
  height: 77px;
  display: flex;
  flex-direction: row;
  overflow-x: scroll;
  overflow-y: hidden;
  -webkit-overflow-scrolling: touch;
  padding: 0 0 0 $grid-gutter-width/2;
  @include media-breakpoint-up(md) {
    padding: 0;
  }
}

.rf-strategy-item {
  height: 77px;
  padding: 10px 0;
  border-top: 3px solid transparent;
  border-bottom: 33px solid rgba($color-skm-red, 0);
  transition: color 0.3s, border-color 0.3s;
  color: $color-secondary-black;
  & + & {
    margin-left: 30px;
  }
}

.rf-strategy-fake-item {
  min-width: 20%;
}

.rf-strategy-session {
  display: none;
}

.type-menu-trigger,
.type-menu-help {
  margin-bottom: 0;
  transition: color 0.3s;
  padding: 0 $grid-gutter-width/1.5;
  position: relative;
  font-size: 13px;
  @include media-breakpoint-up(md) {
    padding: 0 $grid-gutter-width * 1.5;
    font-size: 14px;
  }

  .ic-sm-arrow {
    font-size: 0.615em;
    transition: transform 0.3s;
    display: inline-block;
    transform-origin: center 7.5px;
    position: absolute;
    right: 18px;
    top: 50%;
    margin-top: -9px;
  }
}

.type-menu-help {
  color: $black;
}

.type-menu-toggle:checked ~ * .type-menu-trigger {
  color: $color-skm-red;
  .ic-sm-arrow {
    transform: rotate(-180deg);
  }
}

.type-menu {
  padding-left: $grid-gutter-width/2;
  overflow: hidden;
  max-height: 0;
  transition: max-height 0.5s;
  background-color: $color-genesis-white;
  backdrop-filter: blur(10px);

  .type-menu-toggle:checked ~ & {
    max-height: 130px;

    .type-list {
      opacity: 1;
      transform: none;
      transition: opacity 0.3s 0.1s, transform 0.5s 0.1s;
    }
  }

  @include media-breakpoint-up(md) {
    padding-left: 0;
    position: absolute;
    left: 0;
    width: 100%;
    opacity: 0;
    transition: all 0.3s;
    pointer-events: none;
    background-color: rgba($color-white, 0.9);
    max-height: none;

    .type-menu-toggle:checked ~ & {
      max-height: none;
      opacity: 1;
      pointer-events: auto;
    }
  }
}
.type-list-container {
  width: 100%;
  height: 93px;
  overflow: hidden;
  @include media-breakpoint-up(md) {
    width: auto;
    height: auto;
    overflow: auto;
  }
}

.type-list {
  padding: 10px 0 30px 0;
  opacity: 0;
  transform: translate(0, -100px);
  transition: all 0.3s;
  height: 123px;
  display: inline-flex;
  flex-direction: row;
  overflow-x: scroll;
  overflow-y: hidden;
  width: calc(100% - 10px);
  -webkit-overflow-scrolling: touch;

  @include media-breakpoint-up(md) {
    display: flex;
    flex-flow: row wrap;
    margin: 0 -7px;
    height: auto;
  }
}

.type-item {
  position: relative;
  text-align: center;
  overflow: hidden;
  width: 110px;
  flex-shrink: 0;

  & + & {
    margin-left: 10px;
  }
  &--fake {
    width: 0;
  }

  @include media-breakpoint-up(md) {
    width: auto;
    flex: 0 1 25%;
    flex-shrink: unset;
    margin-bottom: 14px;
    & + & {
      margin-left: 0;
    }
  }

  @include media-breakpoint-up(lg) {
    flex: 0 1 20%;
  }
}

.type-item-inner-wrapper {
  @include media-breakpoint-up(md) {
    padding: 0 7px;
  }
}

.type-item-image {
  border-radius: 2px;
  overflow: hidden;
  position: relative;
  padding-bottom: 66.666%;
  background-color: $color-skm-red;

  &:after {
    content: "";
    position: absolute;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    background-image: linear-gradient(
      to bottom,
      rgba(0, 0, 0, 0),
      rgba(0, 0, 0, 0.5)
    );
    transition: all 0.3s;
  }
}

.type-item-name {
  position: absolute;
  bottom: 0;
  left: 0;
  width: 100%;
  padding: 10px 0;
  font-size: 1em;
  line-height: 1;
  color: $color-white;
  z-index: 1;

  @include media-breakpoint-up(md) {
    padding: 16px 0;
    font-size: 16px;
    font-weight: 300;
  }
}

@each $t in $type-list {
  .type-item-image--#{$t} {
    background: $color-secondary-black
      url("/static/images/restaurant-types/#{$t}@2x.jpg")
      center/cover
      no-repeat;
  }
}

.tabs {
  font-size: 16px;
  .col {
    padding: 0 4px;
  }
  .tab {
    margin: 0;
    cursor: pointer;
    img {
      width: 22px;
      margin-right: 5px;
      vertical-align: middle;
    }
    &__check {
      width: 16px;
      height: 16px;
      border-radius: 16px;
      background-color: $white;
      transition: background 0.15s ease-in;
      vertical-align: middle;
      font-size: 12px;
      font-weight: bolder;
      color: map-get($tab-colors, "default");
      position: absolute;
      left: 8px;
      top: 50%;
      margin-top: -8px;
      text-indent: -2px;
    }
    &__text {
      vertical-align: middle;
    }

    &__cube {
      border-radius: 2px;
      height: 40px;
      background-color: map_get($tab-colors, "default");
      transition: background 0.15s ease-in;
      text-align: center;
      position: relative;
      padding-left: 8px;
      &:before {
        content: "";
        height: 100%;
        display: inline-block;
        vertical-align: middle;
      }
    }

    input:disabled ~ {
      .tab__cube {
        cursor: not-allowed;
        background-color: map_get($tab-colors, "default") !important;
        .tab__check {
          color: map_get($tab-colors, "default") !important;
        }
      }
    }

    &--booking {
      input:checked ~ {
        .tab__cube {
          background-color: map_get($tab-colors, "booking");
          .tab__check {
            color: map_get($tab-colors, "booking");
          }
        }
      }
    }

    &--waiting {
      input:checked ~ {
        .tab__cube {
          background-color: map_get($tab-colors, "waiting");
          .tab__check {
            color: map_get($tab-colors, "waiting");
          }
        }
      }
    }

    &--preorder {
      input:checked ~ {
        .tab__cube {
          background-color: map_get($tab-colors, "preorder");
          .tab__check {
            color: map_get($tab-colors, "preorder");
          }
        }
      }
    }

    &--delivery {
      input:checked ~ {
        .tab__cube {
          background-color: map_get($tab-colors, "delivery");
          .tab__check {
            color: map_get($tab-colors, "delivery");
          }
        }
      }
    }
  }
}
</style>
